import { DispatchItem, AppStore, StoreMapDeclarer, StoreMap, OperateModeSwitch, StoreBaseConstructor, StoreMapDeclarerOptions, RecycleStrategy, DispatchParent } from "event-flux";
import DispatchItemProxy, { IStoreDispatcher } from "./DispatchItemProxy";
import { DisposableLike, CompositeDisposable } from "event-kit";
import LRU from "event-flux/lib/LRU";
declare class StoreMapItemProxy extends DispatchItemProxy {
    constructor(appStore: IStoreDispatcher, storeKey: string, indexKey: string);
}
export declare class StoreMapProxy extends DispatchItemProxy {
    _appStore: IStoreDispatcher;
    _storeKey: string;
    length: number;
    storeMap: Map<string, StoreMapItemProxy>;
    _keyRefs: {
        [key: string]: number;
    };
    _disposables: CompositeDisposable;
    _keyCache: LRU<string> | undefined;
    _recycleStrategy: RecycleStrategy | undefined;
    operateModeSwitch: OperateModeSwitch;
    constructor(appStore: IStoreDispatcher, storeKey: string);
    _inject(appStore: DispatchParent, StoreBuilder: StoreBaseConstructor<any>, stateKey?: string, depStores?: {
        [storeKey: string]: DispatchItem;
    }, initState?: any, options?: StoreMapDeclarerOptions): void;
    _invokeRemoteMethod(method: string, ...args: any[]): void;
    _deleteOne(key: string): void;
    setRecycleStrategy(recycleStrategy: RecycleStrategy, options?: {
        cacheLimit: number | undefined;
    }): void;
    requestStore(storeKey: string): void;
    releaseStore(storeKey: string): void;
    request(keys: string | string[]): DisposableLike;
    _disposeSubStores(): void;
    add(keys: string | string[]): void;
    delete(keys: string | string[]): void;
    get(index: string): StoreMapItemProxy | undefined;
    dispose(): void;
}
export declare class StoreMapProxyDeclarer<T> extends StoreMapDeclarer<T> {
    create(appStore: AppStore & IStoreDispatcher): StoreMap<T>;
}
export {};
//# sourceMappingURL=StoreMapProxy.d.ts.map